program kaladeliu_perdeliojimas;
  { 10 uždavinys }
{----------------------------------------------------------}
  const K = 1000;      { kaladėlių skaičius }
  type kalad = array [1..K] of char;
       numeracija = array [1..K] of 0..K;

  procedure perstatyti (a : kalad;     { pradinė eilė }
                        var b : kalad; { perdėliota eilė }
                        var galima : boolean);
  { nustatoma, ar galima kaladėles perdėlioti taip, kad nei viena raidė
    nepasiliktų savo vietoje ir jei galima - kaladėlės perstatomos }
    var raid : array ['A'..'Z'] of 0..K; { raidžių kartojimų skaičius }
        numer,            { raidžių numeracija }
        kur : numeracija; { kur yra tam tikru numeriu pažymėta kaladėlė }
        nau_num,          { perstatytos kaladėlės numeris }
        i, nm : integer;
        j : char;
  begin
    for j := 'A' to 'Z' do
      raid[j] := 0;
    for i := 1 to K do  { kiek kartų pasikartoja kiekviena raidė }
      raid[ a[i] ] := raid[ a[i] ] + 1;
    galima := true;
    for j := 'A' to 'Z' do
      galima := galima and (raid [j] <= K div 2);
    { jei kaladėlių perstatyti negalima, darbas baigiamas }
    if not galima then exit;
    { jei galima - perstatinėjama }
    { sunumeruojamos kaladėles ir sudaroma lentelė, padedanti rasti
      sunumeruotas kaladėles }
    nm := 0;
    for j := 'A' to 'Z' do
      for i := 1 to K do
        if a[i] = j
           then begin
                  nm := nm + 1;
                  numer[i] := nm;
                  kur[nm] := i
                end;
    { perskaičiuojami kaladėlių numeriai ir perstatomos kaladėlės }
    for i := 1 to K do
      begin
        nau_num := (numer[i] + K div 2 - 1) mod K + 1;
        { i-tosios kaladėlės naujas numeris }
        b[kur[nau_num]] := a[i]
      end
  end;
{----------------------------------------------------------}
var i : integer;
    v : string;
    f : text;
    galima : boolean;  { ar galima kaladėles perdėlioti }
    a, b : kalad;      { pradinis ir perdėliotas kaladėlių masyvai }
begin
  write ('Įveskite pradinių duomenų bylos vardą: ');
  readln (v);
  assign (f, v);       { įvedami pradiniai duomenys }
  reset (f);
  for i := 1 to K do
    read (f, a[i]);
  close (f);

  perstatyti (a, b, galima);

  write ('Įveskite rezultatų bylos vardą: ');
  readln (v);
  assign (f, v);
  rewrite (f);
  if galima     { jei perstatyti galima }
     then for i := 1 to K do
             write (f, b[i])
     else writeln (f, 'NEGALIMA');
  close (f)
end.
